<?php
// GET is encrypted in HTTPS too but server logs will reveal parameters. Handle with care.
if (!$_POST["id"] && $_GET["id"]) $_POST = $_GET;
if (! isset($_SERVER['HTTPS'])) die ("http is not allowed. Use https.");
$login = explode(":", $_POST["id"]);
if (sizeof($login)<2) die ("login incomplete: use id=boxId/login:password to authenticate.");
$cookie = substr($login[0],0,strpos($login[0], '/')); 
if (strlen($cookie)<5) die ("wrong boxid: must be [min 5 digit number]/loginname");
$cmd = explode(":", $_POST["cmd"]);
if (sizeof($cmd)<2) die ("command incomplete: use cmd=deviceId:command");
$server = "https://find.z-wave.me";
$ch = curl_init();
curl_setopt($ch, CURLOPT_COOKIEJAR, $cookie);
curl_setopt($ch, CURLOPT_URL, $server."/zboxweb");
curl_setopt($ch, CURLOPT_POSTFIELDS, "act=login&login=".$login[0]."&pass=".$login[1]);
$s=curl_exec($ch); // execute for authentication
curl_setopt($ch, CURLOPT_COOKIEFILE, $cookie);
curl_setopt($ch, CURLOPT_POST, 0);
curl_setopt($ch, CURLOPT_URL, $server."/ZAutomation/api/v1/devices/".$cmd[0]."/command/".$cmd[1]);
$s=curl_exec($ch); // execute command
curl_close($ch);
unlink($cookie);
?>

<!--
How to place shortcuts on Android Start Screen

Certain functions like opening the door using strike lock must be available quickly without 
opening the Z-Way control app etc. Placing these important commands right
on the Android start screen allows executing them in one click - hence very fast.

First, install the Android App 'HTTP Request Shortcuts' by 'Waboodoo'
https://play.google.com/store/apps/details?id=ch.rmy.android.http_shortcuts

The you need two important information from Z-Way beside your login credentials:
- The name of the device: Click on the Configuration Menu of the element you want to 
control. Element names look like 'ZWayVDev_zway_83-0-37' where 83 is the Z-Wave device
Id, 0 is the instance, 37 is the command class Id (here Switch Binary).
- The command you want to execute. For switches or dimmers it is 'on' and 'off',
for a door lock its 'open' and 'close'. 

Now start the app 'HTTP Shortcuts' and add a new shortcut. Choose name, icon and 
description. Pick 'POST' as Access method and enter the url 'https://service.z-wave.me/zcmd.php'.
For security reasons we strongly recommend to use HTTPS only. HTTP is not protecting your credentials.
Leave authentication and request header untouched. Using the button 'Add parameter' add your 
credentials and the command:

- id: boxId/login:password 
- cmd: element-name:command

We do not recomment to use admin login here. Instead create another user and
grant the device or to the room containing this device to this new user.

Then save the settings and try to execute it by hitting the icon from the list of Shortcuts.
Once everything is ok, make a long push to the icon and choose 'Place on home screen'.
On some phones you need to long push on an empty place on the home screen, then select widgets,
find 'HTTP Request Shortcuts' among the list and then select the desired shortcut to show.

This script can be placed on your own server. Make sure to have PHP and CURL extension installed.
-->
